package com.ynet.life.loaf.compare;

import com.ynet.gene.data.IndexedCollection;
import com.ynet.gene.data.KeyedCollection;
import com.ynet.life.loaf.LoafConfig;
import java.util.List;
import java.util.Map;

/* loaded from: com_ynet_life_loaf_compare.jar:com/ynet/life/loaf/compare/CompareTool.class */
public class CompareTool {
    private Map context;

    public Map getContext() {
        return this.context;
    }

    public void setContext(Map context) {
        this.context = context;
    }

    public CompareTool(Map context) {
        this.context = null;
        this.context = context;
    }

    private String getChangeTip(String fieldName, String originalValue, String changedValue) {
        return LoafConfig.CHANGE_TIP_TGENELATE.replace("$originalValue", originalValue).replace("$newValue", changedValue);
    }

    private boolean judgeICollEqual(IndexedCollection icoll1, IndexedCollection icoll2, String fields) {
        String[] fieldArray = fields.split("\\|");
        boolean flag = false;
        if (icoll1.size() != icoll2.size()) {
            return false;
        }
        int hashValue1 = 0;
        int hashValue2 = 0;
        for (int i = 0; i < icoll1.size(); i++) {
            KeyedCollection kcoll1 = icoll1.getElementAt(i);
            KeyedCollection kcoll2 = icoll2.getElementAt(i);
            for (int j = 0; j < fieldArray.length; j++) {
                if (fieldArray[j].length() > 0) {
                    hashValue1 += kcoll1.get(fieldArray[j]).hashCode();
                    hashValue2 += kcoll2.get(fieldArray[j]).hashCode();
                }
            }
        }
        if (hashValue1 == hashValue2) {
            flag = true;
        }
        return flag;
    }

    public String getChangedValueForSimpleIColl(IndexedCollection icoll, String field, IFormater formater) {
        IndexedCollection originalIColl = new IndexedCollection();
        IndexedCollection changeIColl = new IndexedCollection();
        for (int i = 0; i < icoll.size(); i++) {
            KeyedCollection kcoll = icoll.getElementAt(i);
            String opType = (String) kcoll.get("opType");
            if ("2".equals(opType)) {
                originalIColl.add(kcoll);
            } else if ("1".equals(opType)) {
                changeIColl.add(kcoll);
            }
        }
        if (judgeICollEqual(originalIColl, changeIColl, field)) {
            return getICollValue(originalIColl, field, formater);
        }
        return getChangedValueForSimpleIColl(originalIColl, changeIColl, field, formater);
    }

    public String getChangedValueForSimpleIColl(String icollName, String field, IFormater formater) {
        Map context = getContext();
        IndexedCollection originalIColl = (IndexedCollection) ((Map) context.get("originalData")).get(icollName);
        IndexedCollection changeIColl = (IndexedCollection) context.get(icollName);
        return getChangedValueForSimpleIColl(originalIColl, changeIColl, field, formater);
    }

    private String getChangedValueForSimpleIColl(IndexedCollection originalIColl, IndexedCollection changeIColl, String field, IFormater formater) {
        String opType = (String) getContext().get("opType");
        if ("2".equals(opType)) {
            return getICollValue(originalIColl, field, formater);
        }
        if ("1".equals(opType)) {
            return getICollValue(changeIColl, field, formater);
        }
        String oValue = getICollValue(originalIColl, field, formater);
        String nValue = getICollValue(changeIColl, field, formater);
        if (oValue == null || oValue.length() == 0) {
            oValue = "空";
        }
        if (nValue == null || nValue.length() == 0) {
            nValue = "空";
        }
        return getChangeTip(field, oValue, nValue);
    }

    private String getICollValue(IndexedCollection icoll, String field, IFormater formater) {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < icoll.size(); i++) {
            KeyedCollection kcoll = icoll.getElementAt(i);
            if (i == icoll.size() - 1) {
                sb.append(formater.format((String) kcoll.get(field)));
            } else {
                sb.append(formater.format((String) kcoll.get(field))).append(", ");
            }
        }
        return sb.toString();
    }

    public String getOriginalValue(String fieldName) {
        Map context = getContext();
        String str = (String) context.get(fieldName);
        String fieldValue = str;
        if (str == null || fieldValue.length() == 0) {
            fieldValue = (String) ((Map) context.get("originalData")).get(fieldName);
        }
        return fieldValue;
    }

    public String getChangedValue(String fieldName) {
        return getChangedValue(fieldName, true);
    }

    public String getChangedValue(String fieldName, boolean hasTips) {
        return getChangedValue(fieldName, null, hasTips);
    }

    public String getChangedValue(String fieldName, Map showMap) {
        IFormater formater = new MapFormater(showMap);
        return getChangedValue(fieldName, formater, true);
    }

    public String getChangedValue(String fieldName, IFormater formater) {
        return getChangedValue(fieldName, formater, true);
    }

    public String getChangedValue(String fieldName, IFormater formater, boolean hasTips) {
        Map context = getContext();
        Map originalMap = (Map) context.get("originalData");
        return getChangedValue(fieldName, context, originalMap, formater, hasTips);
    }

    public String getChangedValue(String fieldName, Map changeMap, Map originalMap, IFormater formater, boolean hasTips) {
        String opType = (String) changeMap.get("opType");
        String changeValue = (String) changeMap.get(fieldName);
        String originalValue = (String) originalMap.get(fieldName);
        if (!hasTips) {
            String fieldValue = changeValue;
            if (changeValue == null || fieldValue.length() == 0) {
                fieldValue = originalValue;
            }
            if (formater != null) {
                fieldValue = formater.format(fieldValue);
            }
            return fieldValue;
        }
        if (opType.equals("3") || opType.equals("4")) {
            if (originalMap.containsKey(fieldName)) {
                if (changeValue == null) {
                    if (formater != null) {
                        originalValue = formater.format(originalValue);
                    }
                    return originalValue;
                }
                if (changeValue == null || changeValue.length() == 0) {
                    changeValue = "空";
                } else if (formater != null) {
                    changeValue = formater.format(changeValue);
                }
                if (originalValue == null || originalValue.length() == 0) {
                    originalValue = "空";
                } else if (formater != null) {
                    originalValue = formater.format(originalValue);
                }
                if (changeValue.equals(originalValue)) {
                    return originalValue;
                }
                return getChangeTip(fieldName, originalValue, changeValue);
            }
            if (formater != null) {
                changeValue = formater.format(changeValue);
            }
            return changeValue;
        }
        if (changeValue != null) {
            if (formater != null) {
                changeValue = formater.format(changeValue);
            }
            return changeValue;
        }
        if (formater != null) {
            originalValue = formater.format(originalValue);
        }
        return originalValue;
    }

    public IndexedCollection getChangedIColl(String icollName) {
        return (IndexedCollection) getContext().get(icollName);
    }

    private String getICollChangedValue(String icollName, String fieldName, List primaryFieldList, int index, IFormater formater, boolean hasTips) {
        Map context = getContext();
        IndexedCollection originalIColl = (IndexedCollection) ((Map) context.get("originalData")).get(icollName);
        KeyedCollection changeKColl = (KeyedCollection) ((IndexedCollection) context.get(icollName)).get(index);
        boolean isModify = false;
        String returnValue = null;
        if (originalIColl != null && originalIColl.size() > 0) {
            int i = 0;
            while (true) {
                if (i >= originalIColl.size()) {
                    break;
                }
                KeyedCollection originalKColl = originalIColl.getElementAt(i);
                if (!getPrimaryFieldValue(primaryFieldList, originalKColl).equals(getPrimaryFieldValue(primaryFieldList, changeKColl))) {
                    i++;
                } else {
                    returnValue = getChangedValue(fieldName, changeKColl, originalKColl, formater, hasTips);
                    isModify = true;
                    break;
                }
            }
        }
        if (!isModify) {
            returnValue = (String) changeKColl.get(fieldName);
            if (formater != null) {
                returnValue = formater.format(returnValue);
            }
        }
        return returnValue;
    }

    public String getICollChangedValue(String icollName, String fieldName, List primaryFieldList, int index, IFormater formater) {
        return getICollChangedValue(icollName, fieldName, primaryFieldList, index, formater, true);
    }

    public String getICollChangedValue(String icollName, String fieldName, List primaryFieldList, int index) {
        return getICollChangedValue(icollName, fieldName, primaryFieldList, index, null);
    }

    private String getPrimaryFieldValue(List primaryFieldList, Map map) {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < primaryFieldList.size(); i++) {
            String field = (String) primaryFieldList.get(i);
            String str = (String) map.get(field);
            String value = str;
            if (str == null) {
                value = "";
            }
            sb.append(value);
        }
        return sb.toString();
    }
}
